/*
 * (C) 2011 Nidera (www.nidera.com). All rights reserved.
 */
package org.jarbframework.constraint.metadata.database;

import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * Mark a property as database generated. Meaning that a value
 * can always be generated by the database, this could e.g. be
 * implemented by a default value, trigger or auto-incremental type.
 *
 * @author Jeroen van Schagen
 * @date Aug 16, 2011
 */
@Documented
@Target({ FIELD, METHOD })
@Retention(RUNTIME)
public @interface DatabaseGenerated {
}
